module("luci.controller.themedog",package.seeall)
function index()
entry({"admin","themedog"},call("themedog_template"))
if nixio.fs.access("/usr/lib/lua/luci/view/themedog/main_dev.htm")then
entry({"admin","themedog_dev"},call("themedog_template_dev"))
end
entry({"admin","themedog","api"},call("redirect_index"))
entry({"admin","themedog","api","status"},call("themedog_api_status"))
entry({"admin","themedog","api","version"},call("themedog_api_version"))
entry({"admin","themedog","api","memory"},call("themedog_api_memory"))
entry({"admin","themedog","api","cpu"},call("themedog_api_cpu"))
entry({"admin","themedog","api","upload-bg"},call("themedog_api_uploadbg"))
end
function redirect_index()
luci.http.redirect(luci.dispatcher.build_url("admin/themedog"))
end
function themedog_template()
luci.template.render("themedog/main")
end
function themedog_template_dev()
luci.template.render("themedog/main_dev")
end
function themedog_api_status()
local e=luci.sys.exec("printf \"%d\" $(date +%s)")
local t=luci.sys.uptime()
local e={
locallTime=tonumber(e),
uptime=t
}
local e={
success=true,
result=e
}
luci.http.prepare_content("application/json")
luci.http.write_json(e)
end
function themedog_api_version()
local e=luci.sys.exec("opkg list luci-themedog")
local e={
version=e
}
local e={
success=true,
result=e
}
luci.http.prepare_content("application/json")
luci.http.write_json(e)
end
function themedog_api_memory()
local e=luci.sys.exec("cat /proc/meminfo |grep MemTotal |awk -F ' ' '{printf(\"%d\",$2)}'")
local t=luci.sys.exec("free -h |grep Mem |awk -F ' ' '{printf(\"%d\", $7)}'")
local e={
total=tonumber(e),
available=tonumber(t)
}
local e={
success=true,
result=e
}
luci.http.prepare_content("application/json")
luci.http.write_json(e)
end
function themedog_api_cpu()
local t=luci.sys.exec("top -n1 | awk '/^CPU:/ {printf(\"%d\",$8)}'")
local e=luci.sys.exec("cut -c1-2 /sys/class/thermal/thermal_zone0/temp")
local e={
total=100,
available=tonumber(t),
temperature=tonumber(e)
}
local e={
success=true,
result=e
}
luci.http.prepare_content("application/json")
luci.http.write_json(e)
end
function themedog_api_uploadbg()
local e=require"uci"
local e=e.cursor()
local e
local o
local a=false
local n="/www/luci-static/themedog/image"
local t=""
luci.http.setfilehandler(
function(h,i,s)
if not e then
t=h.file
o=n.."/bg.gif"
e=io.open(o,"w")
end
if i then
e:write(i)
end
if s then
e:close()
a=true
end
end
)
luci.http.formvalue("file")
local e={
filename=t
}
local e={
success=a,
result=e
}
luci.http.prepare_content("application/json")
luci.http.write_json(e)
end